#define F_CPU 16000000

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

char table[8][8]= {"TCNQRNCT",
					"PPPPPPPP",
					"EEEEEEEE",
					"EEEEEEEE",
					"EEEEEEEE",
					"EEEEEEEE",
					"EEEEEEEE",
					"PPPPPPPP",
					"TCNRQNCT",
					};


int move[4];
int counter;

int is_valid(char p1,char p2){
	if (p1=='E')
		return 0;
	return 1;
}

void update_table(){
	char p1,p2;
	p1=table[7-move[0]][move[1]];
	p2=table[7-move[2]][move[3]];
	if (p1!='E' && is_valid(p1,p2)==1){
		table[7-move[0]][move[1]]='E';
		table[7-move[2]][move[3]]=p1;
		}
		
}
ISR(PCINT1_vect) {

	if ((PINB & (1 << PB0)) == 0) {
			move[counter]=0;
			counter++;
			if (counter==4)
				update_table();
			PORTD ^= (1 << PD7);
		}
    
	if ((PINB & (1 << PB1)) == 0) {
			move[counter]=1;
			counter++;
			if (counter==4)
				update_table();
			PORTD ^= (1 << PD7);
		}
		
	if ((PINB & (1 << PB2)) == 0) {
			move[counter]=2;
			counter++;
			if (counter==4)
				update_table();
			PORTD ^= (1 << PD7);
		}
		
	if ((PINB & (1 << PB3)) == 0) {
			move[counter]=3;
			counter++;
			if (counter==4)
				update_table();
			PORTD ^= (1 << PD7);
		}
		
	if ((PINB & (1 << PB4)) == 0) {
			move[counter]=4;
			counter++;
			if (counter==4)
				update_table();
			PORTD ^= (1 << PD7);
		}
		
	if ((PINB & (1 << PB5)) == 0) {
			move[counter]=5;
			counter++;
			if (counter==4)
				update_table();
			PORTD ^= (1 << PD7);
		}
		
	if ((PINB & (1 << PB6)) == 0) {
			move[counter]=6;
			counter++;
			if (counter==4)
				update_table();
			PORTD ^= (1 << PD7);
		}
		
	if ((PINB & (1 << PB7)) == 0) {
			move[counter]=7;
			counter++;
			if (counter==4)
				update_table();
			PORTD ^= (1 << PD7);
		}
}

int main(void) {
	
	/* Setez pinii PD6 ca pini de intrare. */
	DDRB &= ~((1 << PB0)|(1 << PB1)|(1 << PB2)|(1 << PB3)|(1 << PB4)|(1 << PB5)|(1 << PB6)|(1 << PB7));

	/* Activez rezistenta de pull-up pentru pinii PD6. */
	PORTB |= (1 << PB0)|(1 << PB1)|(1 << PB2)|(1 << PB3)|(1 << PB4)|(1 << PB5)|(1 << PB6)|(1 << PB7);

	/* Setez pinul PD7 ca iesire. */
	DDRD |= (1 << PD7);

	/* Opresc led-ul. */
	PORTD &= ~(1 << PD7);
	
	PCICR  = (1 << PCIE1);
    PCMSK1 = (1 << PCINT8|1 << PCINT9|1 << PCINT10|1 << PCINT11|1 << PCINT12|1 << PCINT13|1 << PCINT14|1 << PCINT15);
	
	counter=0;

	sei();	
	while(1);

	return 0;
}
